#ifndef __MACRO_H__
#define __MACRO_H__


// Return a mask on the given bit
#define BIT(X) (1 << (X))


#define SETBITS(X,Y) ((X) |= (Y))
#define CLEARBITS(X,Y) ((X) &= (~(Y)))

// Set the bit y of X
#define SETBIT(X,y) SETBITS((X), (BIT((y))))

// Clear the bit y of X
#define CLEARBIT(X,y) CLEARBITS((X), (BIT((y))))

// Return true if the bit y of X is set
#define BITSET(X,y) ((X) & (BIT(y)))

// Return true if the bit y of X is not set
#define BITCLEAR(X,y) !BITSET((X), (y))

// Return true if all the bits of Y are set in X
#define BITSSET(X,Y) (((X) & (Y)) == (y))

// Return true if all the bits of Y are not set in X
#define BITSCLEAR(X,y) (((X) & (y)) == 0)
#define BITVAL(X,y) (((X)>>(y)) & 1)



#endif   //__MACRO_H__